;	t@CF12864OSL1.asm	2014.02.16@//2014.05.06
;      3Digts dv                                      jk1xkp
;      QlāFmVAD.asm ;	gp
;	ohb		PIC16F819   assembler ;MPLAB
;
;		NbN	8MHz;

;sATCFidENX^E̔z͏ȗj
;		( H:[qopen(LED̐ڑ̂݁j  L:[q4.7kGRDɗƂ)
;	ohbPUeWPX	LEDW[(A-F)
;	()̓sԍ
;	RA7-OSC1(16)	D/I	
;	RA6-OSC2(15)	E		
;	RA5-MCR (4)		=EXT Triger
;	RA4(03)			RST		
;	RA3(02)				Ref+ B+2.7VڑArd  
;	RA2(01)				CS1=H(CS=L), CS2=H(CS=H)
;	RA1(18)				NC
;	RA0(17)				Vin
;	RB7(13)			DB0	    
;	RB6(12)			DB1	L=	 -80dB(0.2V)`-20dBm(1.7V)
;	RB5(11)			DB2	L=	 -60dB(0.7V)` 0dBm(2.2V)
;							Non1k=-40dB(1.2V)`+20dBm(2.7V)
;	RB4(10)			DB3		
;	RB3(09)			DB4	
;	RB2(08)			DB5	
;	RB1(07)			DB6	
;	RB0(06)			DB7	L=	0.1sec/div
;							Non1k=	1sec			
;
;        
		LIST		P=16F819	
		INCLUDE		"P16F819.INC"	; ł͂PUeWPXI
	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_ON & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_IO 

#define		Trig   	PORTA,5		;external Trigger
#define		E   	PORTA,6		;LCD E
#define		DI   	PORTA,7		;LCD D/I
#define		RST   	PORTA,4		;LCD RST
#define		CS   	PORTA,2		;LCD CS


;***** VARIABLE DEFINITIONS
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
			
;   --------------- adress 20&H  
wait_cn		EQU	H'20'
wait_cn2	EQU	H'21'
cn    		EQU	H'22'
cm   		EQU	H'23'		;sub-counter 
x0       	EQU	H'24'	
x1      	EQU	H'25'
x2      	EQU	H'26'
x3  		EQU	H'27'
v0   		EQU	H'28'	;df[^(0 `108)
pV0   		EQU	H'29'	;previous v0 df[^
v2   		EQU	H'2a'
v3  		EQU	H'2b'
y0  		EQU	H'2c'
y1   		EQU	H'2d'
y2   		EQU	H'2e'
y3  	  	EQU	H'2f'
poi     	EQU	H'30'
mode		EQU	H'31'	;
oldmode		EQU	H'32'	; 
Font  		EQU	H'33'	; Font= 1st 4dot of H'0f'=B'00001111' dBplus00
pD0		EQU	H'34'	; 0page B8
pD1		EQU	H'35'	; 1page B9
pD2		EQU	H'36'	; 2page BA
pD3		EQU	H'37'	; 3page BB
pD4		EQU	H'38'	; 4page BC
pD5		EQU	H'39'	; 5page BD
pD6		EQU	H'3a'	; 6page BE
pD7		EQU	H'3b'	; 7page BF
N_cl		EQU	H'3c'	;Clomn ʂAO`PQV
clmn		EQU	H'3d'	;Clm 0`63  //H'40'(0)`H'77'(63)
N_12		EQU	H'3e'	;12sLine, 0`12@0`12
N_12sub		EQU	H'3f'	; N_12=50 Check⏕
val0		EQU	H'40'		; ϊliRQrbgj
val1		EQU	H'41'
val2		EQU	H'42'
val3		EQU	H'43'
val_m		EQU	H'44'		; ꎞ]i[ꏊiTu[`Ŏgpj
ADL			EQU	H'45'	;ADϊ@ADRESL
ADH			EQU	H'46'	;ADϊ@ADRESH
N_Pg		EQU	H'47'	;dotłĂ@active  Page Pg_act=0 `7
p_d8		EQU	H'48'	;d8 swap0Ó@data
d8			EQU	H'49'
cn_ad		EQU	H'4a'	;cn_ad=10(1sec), cn_ad=5(0.5sec),cn_ad=1(0.1sec),
cn_cl   	EQU	H'4b'	;sub-counter;		
N     		EQU	H'4c'		;	
sG0		EQU	H'4d'	; 0page B8 	small G0 decided with V0 or pV0
sG1		EQU	H'4e'	; 1page B9
sG2		EQU	H'4f'	; 2page BA
sG3		EQU	H'50'	; 3page BB
sG4		EQU	H'51'	; 4page BC
sG5		EQU	H'52'	; 5page BD
sG6		EQU	H'53'	; 6page BE
sG7		EQU	H'54'	; 7page BF

G0		EQU	H'55'	; 0page B8 large G0 decided with V0 or pV0
G1		EQU	H'56'	; 1page B9
G2		EQU	H'57'	; 2page BA
G3		EQU	H'58'	; 3page BB
G4		EQU	H'59'	; 4page BC
G5		EQU	H'5a'	; 5page BD
G6		EQU	H'5b'	; 6page BE
G7		EQU	H'5c'	; 7page BF
char0	EQU	H'5d'	;1st	;3ō
char1	EQU	H'5e'	;2nd
char2	EQU	H'5f'	;3rd
char3	EQU	H'60'	;space
char4	EQU	H'61'	;1st;3ԕ
char5	EQU	H'62'	;2nd
char6	EQU	H'63'	;3rd
char7	EQU	H'64'	;space
char8	EQU	H'65'	;1st	G3ŉE
char9	EQU	H'66'	;2nd	
char10	EQU	H'67'	;3rd	
char11	EQU	H'68'	;space	
vfc		EQU	H'69'	;interrupt Flag
		;;Min.40h-Max.7Fh
	
		org 	H'0000'
		goto	start
		ORG     0x004             ; interrupt vector location
isr		;;荞ݏ-routine
i_rb0	movwf	w_temp		;W@File w_tempւ̕ۑ
		swapf	STATUS,0
		clrf	STATUS		;Bank0
		movwf	status_temp	;status@File@̕ۑ
	;	bcf		INTCON,GIE
				;0.1sec/ ;PSA;16x TMR125=2,000 //256-125=131
;		bsf  	STATUS,RP0	;oN1
;		movlw	B'00010011'	;;prescaler 1/16 set ;;0.1sec
;		movwf	OPTION_REG	
;		bcf		STATUS,RP0	;oN0

		movlw	D'131'	;;0.1sec
		movwf	TMR0
Intrpt	call	adloop	;AD Conversion replacement

pop		swapf	status_temp,0	;status@File@̖߂
		movwf	STATUS	
		swapf	w_temp,1	;W@File@̖߂
		swapf	w_temp,0
		bcf		INTCON,1	;intcon-INTF(tOj̃Zbg
		bcf		INTCON,2	;intcon-TMR0IF(tOj̃Zbg		
		bsf		INTCON,GIE 		; Enable INTs.
		bsf		vfc,0		;vfo change record, vfc=1		
		retfie
;-----------
; remaining code goes here
R_NPg	;N_pg //Reverse of DB0-DB8	
	addwf	PCL,1  		;cycle3
	retlw	B'00011101'	;"0"
	retlw	B'10011101'	;"1"
	retlw	B'01011101'	;"2"
	retlw	B'11011101'	;"3"
	retlw	B'00111101'	;"4"
	retlw	B'10111101'	;"5"
	retlw	B'01111101'	;"6"
	retlw	B'11111101'	;"7"
	retlw	B'00011101'	;"8" ;Dummy


Font1st		;1st Column.
	addwf	PCL,1  		;cycle3
	retlw	B'00111111'	;"0"
	retlw	B'00000000'	;"1"
	retlw	B'01111001'	;"2"
	retlw	B'01001001'	;"3"
	retlw	B'00001111'	;"4"
	retlw	B'01001111'	;"5"
	retlw	B'01111111'	;"6"
	retlw	B'00000111'	;"7"
	retlw	B'01111111'	;"8"
	retlw	B'01001111'	;"9"
	retlw	B'01111111'	;"A"
	retlw	B'01111111'	;"b"
	retlw	B'01111111'	;"C"
	retlw	B'01111000'	;"d"
	retlw	B'01111111'	;"E"
	retlw	B'00000000'	;F"f"=
	retlw	B'00000000'	;"10"="."	
	retlw	B'00001000'	;"11"="-"
	retlw	B'00001000'	;"12"="+"
	retlw	B'00111100'	;"13"="n"
	retlw	B'01111111'	;"14"="F"
	retlw	B'00111100'	;"15"="r"	
	sleep

Font2nd			;2nd Column .
	addwf	PCL,1  		;cycle3
	retlw	B'00100001'	;"0"
	retlw	B'01111111'	;"1"
	retlw	B'01001001'	;"2"
	retlw	B'01001001'	;"3"
	retlw	B'00001000'	;"4"
	retlw	B'01001001'	;"5"
	retlw	B'01001001'	;"6"
	retlw	B'00000001'	;"7"
	retlw	B'01001001'	;"8"
	retlw	B'01001111'	;"9"
	retlw	B'00001001'	;"A"
	retlw	B'01001000'	;"b"
	retlw	B'01000001'	;"C"
	retlw	B'01001000'	;"d"
	retlw	B'01001001'	;"E"
	retlw	B'00000000'	;F"f"=
	retlw	B'01100000'	;"10"="."
	retlw	B'00001000'	;"11"="-"
	retlw	B'00111110'	;"12"="+"
	retlw	B'00001000'	;"13"="n"
	retlw	B'00001001'	;"14"="F"
	retlw	B'00001000'	;"15"="r"	
	sleep

Font3rd		;3rd Column.
	addwf	PCL,1  		;cycle3
	retlw	B'00111111'	;"0"
	retlw	B'00000000'	;"1"
	retlw	B'01001111'	;"2"
	retlw	B'01111111'	;"3"
	retlw	B'01111111'	;"4"
	retlw	B'01111001'	;"5"
	retlw	B'01111001'	;"6"
	retlw	B'01111111'	;"7"
	retlw	B'01111111'	;"8"
	retlw	B'01111111'	;"9"
	retlw	B'01111111'	;"A"
	retlw	B'01111000'	;"b"
	retlw	B'01000001'	;"C"
	retlw	B'01111111'	;"d"
	retlw	B'01001001'	;"E"
	retlw	B'00000000'	;F"f"=
	retlw	B'00000000'	;"10"="."	
	retlw	B'00001000'	;"11"="-"
	retlw	B'00001000'	;"12"="+"
	retlw	B'00111000'	;"13"="n"
	retlw	B'00001001'	;"14"="F"
	retlw	B'00001000'	;"15"="r
	sleep

;DotBar	;LCD Grid serial Row
	;	andlw	B'00000111'
	;	addwf	PCL,1  		;cycle3 
	;	retlw	B'10000000'	;grid 0 H'80'
	;	retlw	B'11000000'	;grid 1	H'C0'	
	;	retlw	B'11100000'	;grid 2 H'D0'        	
	;	retlw	B'11110000'	;grid 3 H'F0'       
	;	retlw	B'11111000'	;grid 4 H'F8'    
	;	retlw	B'11111100'	;grid 5 H'FC'     
	;	retlw	B'11111110'	;grid 6 H'FE'    
	;	retlw	B'11111111'	;grid 7 H'FF'   
	;	retlw	B'11111111'	;grid 7 H'FF'      
	;	sleep
R_DotBar	; Reverse of DotBar
		andlw	B'00000111'
		addwf	PCL,1  		;cycle3 
		retlw	B'00000001'	;grid 0 H'01'
		retlw	B'00000011'	;grid 1	H'03'	
		retlw	B'00000111'	;grid 2 H'07'        	
		retlw	B'00001111'	;grid 3 H'0F'       
		retlw	B'00011111'	;grid 4 H'1F'    
		retlw	B'00111111'	;grid 5 H'3F'     
		retlw	B'01111111'	;grid 6 H'7F'    
		retlw	B'11111111'	;grid 7 H'FF'   
		retlw	B'11111111'	;grid 7 H'FF'      
		sleep	

;Gridpage	;
	;	movf	N_12,1
	;	btfsc	STATUS,Z	; if N_12=0 <;12sLine>, then B'01010101'
	;	retlw	B'10101010'

	;	btfsc	N_12,0	;if "N_12,0" = "1" //0101Ƃ邽
	;	retlw	B'00000000'

	;	movf	N_Pg,0		;Page set
	;	addwf	PCL,1  		;cycle3
	;	retlw	B'00001000'	;0page H'04'
	;	retlw	B'00100000'	;1page H'20'		
	;	retlw	B'10000000'	;2page H'80'        
	;	retlw	B'00000000'	;3page H'00'
	;	retlw	B'00000010'	;4page H'02'
	;	retlw	B'00001000'	;5page H'04'
	;	retlw	B'00100000'	;6page H'20'
	;	retlw	B'10000000'	;7page H'80'  
	;	retlw	B'10000000'	;7page H'80'  
	;	sleep
R_Gridpage	;reverse of Gridpage
		movlw	D'50'	
		subwf	N_12sub,0	;;if N_12sub=H'50'
		btfsc	STATUS,Z
		retlw	B'10101011'

		movlw	B'00001111'
		andwf	N_12,0
		btfsc	STATUS,Z	; if N_12=0 <;10sLine>, then B'01010101'
		retlw	B'01010101'	

		btfsc	N_12,0	;if "N_12,0" = "1" //0101Ƃ邽
		retlw	B'00000000'

		movf	N_Pg,0		;Page set
		addwf	PCL,1  		;cycle3
		retlw	B'10000000'	;0page H'F0'
		retlw	B'00100000'	;1page H'20'		
		retlw	B'00001000'	;2page H'08'        
		retlw	B'00000010'	;3page H'02'
		retlw	B'00000000'	;4page H'00'
		retlw	B'10000000'	;5page H'f0'
		retlw	B'00100000'	;6page H'20'  
		retlw	B'00001000'	;7page H'08'  
		sleep

sec10	;1bSCAN@
		addwf	PCL,1  		;cycle3
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'00010101'	;H'0f' page N_Pg=0 		"S"
		retlw	B'00001111'	;H'0f' page N_Pg=1			
		retlw	B'00100001'	;H'01' page N_Pg=2    	H'f1'=" 1"    
		retlw	B'00000101'	;H'05' page N_Pg=3		H'f5'=" S"
		retlw	B'00001111'	;H'0f' page N_Pg=4 		
		retlw	B'00001010'	;H'0f' page N_Pg=5 		"0A"="A"
		retlw	B'00000011'	;H'0f' page N_Pg=6 		"03"="3"
		retlw	B'00001111'	;H'0f' page N_Pg=7 

		retlw	H'C3'	;page N_Pg=0 +8 			"Cn"
		retlw	H'ff'	;page N_Pg=1 					
		retlw	H'00'	;page N_Pg=2  			H'"10+00" 0'=".0"      
		retlw	H'EC'	;page N_Pg=3			H'EC'="EC"	
		retlw	H'ff'	;page N_Pg=4			
		retlw	H'd8'	;page N_Pg=5			"d8"="d8"	
		retlw	H'07'	;page N_Pg=6 			"07"="07"
		retlw	H'ff'	;page N_Pg=7    
		sleep

sec05	;0.5bSCAN@
		addwf	PCL,1  		;cycle3
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'00010101'	;H'0f' page N_Pg=0 		"S"
		retlw	B'00001111'	;H'0f' page N_Pg=1		
		retlw	B'00100000'	;H'00' page N_Pg=2  	H'f1'=" 0"      
		retlw	B'00000101'	;H'05' page N_Pg=3		H'f5'=" S"
		retlw	B'00001111'	;H'0f' page N_Pg=4 		
		retlw	B'00001010'	;H'0f' page N_Pg=5 		"0A"="A"
		retlw	B'00000011'	;H'0f' page N_Pg=6 		"03"="3"
		retlw	B'00001111'	;H'0f' page N_Pg=7 

		retlw	H'C3'	;page N_Pg=0 +8 			"Cn"
		retlw	H'ff'	;page N_Pg=1 
		retlw	H'05'	;page N_Pg=2   			H'"10+00" 0'=".5"     
		retlw	H'EC'	;page N_Pg=3			H'EC'="EC"
		retlw	H'ff'	;page N_Pg=4			
		retlw	H'd8'	;page N_Pg=5			"d8"="d8"	
		retlw	H'07'	;page N_Pg=6 			"07"="07"
		retlw	H'ff'	;page N_Pg=7    
		sleep

sec01	;0.1bSCAN@
		addwf	PCL,1  		;cycle3
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'00010101'	;H'0f' page N_Pg=0 		"S"
		retlw	B'00001111'	;H'0f' page N_Pg=1				
		retlw	B'00100000'	;H'00' page N_Pg=2   	H'f1'=" 0"     
		retlw	B'00000101'	;H'05' page N_Pg=3		H'f5'=" S"
		retlw	B'00001111'	;H'0f' page N_Pg=4 		
		retlw	B'00001010'	;H'0f' page N_Pg=5 		"0A"="A"
		retlw	B'00000011'	;H'0f' page N_Pg=6 		"03"="3"
		retlw	B'00001111'	;H'0f' page N_Pg=7 

		retlw	H'C3'	;page N_Pg=0 +8 			"Cn"
		retlw	H'ff'	;page N_Pg=1 
		retlw	H'01'	;page N_Pg=2 			H'"10+00" 0'=".1"       
		retlw	H'EC'	;page N_Pg=3			H'EC'="EC"
		retlw	H'ff'	;page N_Pg=4		
		retlw	H'd8'	;page N_Pg=5			"d8"="d8"	
		retlw	H'07'	;page N_Pg=6 			"07"="07"
		retlw	H'ff'	;page N_Pg=7    
		sleep

dBplus20	;
		addwf	PCL,1  		;cycle3	
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'01000010'	;H'0f' page N_Pg=0 		H'F+1'="+"
		retlw	B'00001111'	;H'0f' page N_Pg=1		
		retlw	B'00001111'	;H'0f' page N_Pg=2        
		retlw	B'00001111'	;H'0f' page N_Pg=3
		retlw	B'00001111'	;H'0f' page N_Pg=4 
		retlw	B'01000001'	;H'0B' page N_Pg=5 			="-"
		retlw	B'00001111'	;H'0f' page N_Pg=6 
		retlw	B'01000001'	;H'0B' page N_Pg=7 		H'10+01'="-"

		retlw	H'20'	;page N_Pg=0 +8			"20"	
		retlw	H'd8'	;page N_Pg=1 H'd8'="dB"		
		retlw	H'0f'	;page N_Pg=2 			"0"       
		retlw	H'ff'	;page N_Pg=3
		retlw	H'ff'	;page N_Pg=4
		retlw	H'20'	;page N_Pg=5			"20"
		retlw	H'ff'	;page N_Pg=6 
		retlw	H'40'	;page N_Pg=7 			"40"   
		sleep

dBplus00	;
		addwf	PCL,1  		;cycle3
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'00001111'	;H'0f' page N_Pg=0 
		retlw	B'00001111'	;H'0f' page N_Pg=1		
		retlw	B'01000001'	;H'0f' page N_Pg=2   	H'10+01'="-"     
		retlw	B'00001111'	;H'0B' page N_Pg=3 	
		retlw	B'00001111'	;H'0f' page N_Pg=4 
		retlw	B'01000001'	;H'0B' page N_Pg=5 		H'10+01'="-"
		retlw	B'00001111'	;H'0f' page N_Pg=6 
		retlw	B'01000001' ;H'0B' page N_Pg=7 		H'10+01'="-" 

		retlw	H'0f'	;page N_Pg=0 +8				"0"
		retlw	H'd8'	;page N_Pg=1 H'd8'="dB"	
		retlw	H'20'	;page N_Pg=2     			"20"   
		retlw	H'ff'	;page N_Pg=3	
		retlw	H'ff'	;page N_Pg=4 
		retlw	H'40'	;page N_Pg=5				"40"
		retlw	H'ff'	;page N_Pg=6 
		retlw	H'60'	;page N_Pg=7 				"60"   
		sleep

dBminus20	;
		addwf	PCL,1  		;cycle3
			;;	; N123 	;1ځA2ځARځ@//ꕶ@F
	;;From left +16 for[None][1st Chara][2nd Chara][3rd Chara]
		retlw	B'01000001'	;H'0B' page N_Pg=0 H'10+01'="-"  
		retlw	B'00001111'	;H'0f' page N_Pg=1		
		retlw	B'01000001'	;H'0f' page N_Pg=2 H'10+01'="-"       
		retlw	B'00001111'	;H'0B' page N_Pg=3 
		retlw	B'00001111'	;H'0f' page N_Pg=4 
		retlw	B'01000001'	;H'0B' page N_Pg=5 H'10+01'="-"
		retlw	B'00001111'	;H'0f' page N_Pg=6 
		retlw	B'01000001'	;H'0B' page N_Pg=7 H'10+01'="-"    

		retlw	H'20'	;page N_Pg=0  +8
		retlw	H'd8'	;page N_Pg=1 H'd8'="dB"		
		retlw	H'40'	;page N_Pg=2        
		retlw	H'ff'	;page N_Pg=3
		retlw	H'ff'	;page N_Pg=4 
		retlw	H'60'	;page N_Pg=5
		retlw	H'ff'	;page N_Pg=6 
		retlw	H'80'	;page N_Pg=7    
		sleep


start	;;;;;;;test
	 ;	clrf	N_cl
	;	clrf	N_12
st0	;	nop
	;	call	N12_inc
	;	goto	st0
		;;;;;;;test
	
		bsf  	STATUS,RP0	;oN1		
		movlw	B'01110100'	;OSC=8MHz
		movwf	OSCCON

		movlw	B'11000101'	;pinset(AN4=D,AN3=Ref+,AN2=D,AN1=Analog,AN0=Analog) resultE
		movwf	ADCON1
		movlw	B'00101011'	;ra2,,4,6,7  inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA

		clrf	poi
		clrf	d8
		clrf	pV0		
		clrf	N_Pg	
		clrf	p_d8		
		clrf	cn_cl  
		clrf	N_12 
		clrf	N_12sub	
		clrf	clmn	
		clrf	vfc
		bcf		RST
		movlw	D'255'
		movwf	wait_cn
		call	wait_ms
		bsf		RST

		bsf  	STATUS,RP0	;oN1
		movlw	B'00010100'	;RBvAbv;RBvAbv; RB0JEg; IntClk;prescaler 1/32 set ;
		movwf	OPTION_REG	
		bcf  	STATUS,RP0	;oN0

		bsf  	STATUS,RP0	;oN1
		movlw	B'11111111'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB
		movf	PORTB,0		;portb ǂݍ
		andlw	B'00001111'
		movwf	mode

		bsf  	STATUS,RP0	;oN1
		movlw	B'00000000'	;rb.0-rb.7sout  
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		;===============
		call	initLCD
		call	dspdBm	; +20dBm, 0dBm, -20dBm
		movlw	D'113'
		movwf	N_cl
		call	Spa_ce  ;113s@Space
		movlw	D'126'
		movwf	N_cl		
		call	Spa_ce  ;126s@Space
		movlw	D'127'
		movwf	N_cl
		call	Spa_ce  ;127s@Space
		call	SECDSP	;;Displaying ;1.0SEC ,0.5SEC, 0.1SEC//114`125
		;===============
st30	clrf	N_12	;10s
		movlw	D'101'
		movwf	cn_cl
		movlw	D'12'
		movwf	N_cl	;Line=8 ``127
st31	clrf	v0	;dot data=0
		call	pD_set	;cP\PDset//@N_12@(;LineP0s), 
		call	L_dot	;N_cl, pD_n(;v0dް) čs

		call	N12_inc	 ;incf	N\cl & N_12
		decfsz	cn_cl,1
		goto	st31

S_end	movlw	B'00100000'		;TMR0INT.5=1 GIE=1 enable, INTE=1 enable
		movwf	INTCON
		
main;	clrf	N_12	;10s
	;	movlw	D'12'
	;	movwf	N_cl	;Line=12

	;	bsf  	STATUS,RP0	;oN1
	;	movlw	B'00000000'	;rb.0-rb.7sout  
	;	movwf	TRISB		;trisb
	;	bcf  	STATUS,RP0	;oN0

	;	call	pD_set	;cP\PDset//@N_12@(;LineP0s), 
	;	call	L_dot	;N_cl, pD_n(;v0dް) čs N_cl=12s\

main1		;clrf	pV0
		bsf  	STATUS,RP0	;oN1
		movlw	B'00010011'	;;prescaler 1/16 set ;;0.1sec
		movwf	OPTION_REG	

		movlw	B'11111111'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB
m11		movf	PORTB,0		;portb ǂݍ
		andlw	B'00001111'
		movwf	mode
		subwf	oldmode,0
		btfsc	STATUS,Z
		goto	m12
		movf	mode,0
		movwf	oldmode	
		call	dspdBm	; +20dBm, 0dBm, -20dBm
		call	SECDSP	;;Displaying ;1.0SEC ,0.5SEC, 0.1SEC

m12		btfss	Trig
		goto	main1
		nop
m13		btfsc	Trig
		goto	m13	
m14		btfsc	Trig
		goto	m14	

m15		bsf  	STATUS,RP0	;oN1
		movlw	B'00000000'	;rb.0-rb.7sout  
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0

m16			;0.1sec/ ;PSA;16x TMR125=2,000 //256-125=131
		bsf  	STATUS,RP0	;oN1
		movlw	B'00010011'	;;prescaler 1/16 set ;;0.1sec
		movwf	OPTION_REG	
		bcf		STATUS,RP0	;oN0
		movlw	D'131'	;;0.1sec
		movwf	TMR0

		movlw	D'100'		
		movwf	cn_cl
		movlw	D'12'
		movwf	N_cl		;Clomn ʂA8`127
		clrf	N_12	;LINE@each 10 clm s
		clrf	N_12sub
		bsf		vfc,0		;vfo change record, vfc=1	
		bcf		INTCON,1	;intcon-INTF(tOj̃Zbg
		bcf		INTCON,2	;intcon-TMR0IF(tOj̃Zbg
		bsf		INTCON,GIE	;GIE=1 enable, :

main2	movlw	D'10'	;	;1sec/
		btfss	mode,2	
		goto	main22

main21	movlw	D'5'	;;0.5sec/
		btfss	mode,3	
		movlw	D'1'	;;0.1sec

main22	movwf	cn_ad	;;cn_ad=10(1sec), cn_ad=5(0.5sec),cn_ad=1(0.1sec),

main25	clrf	ADH
		clrf	ADL
		;(main routin 2000cycle 900 or =0.45msec)
	;---------------
main3	btfss	vfc,0	;Intrrupt Trap
		goto	main3			
		bcf		vfc,0
		decfsz	cn_ad,1
		goto	main25

main4	call	pD_set	;N_cl & N_Pgā@==setting pD0-pD7	;100cycle

mv2		movf	ADH,0
		movwf	y1		;ADϊʂ@y1,y0Ɏ荞݁@10bit=max1023
		movwf	x1

		movf	ADL,0
		movwf	y0
		movwf	x0
		clrf	y2
		clrf	y3
		clrf	x2
		clrf	x3	

mv3		;x=y*108/1023=y*1.689/16=y*(1+ 1/2+ 1/8 +1/16)/16
				;90cycle
		bcf		STATUS,C	;y=y/2							;25cycle
		rrf		y1,1
		rrf 	y0,1
		call	add_xy		;(32bit)(32bit){y(32bit)	;x==y*(1+ 1/2)

		bcf		STATUS,C	;y=y/4							;25cycle
		rrf		y1,1
		rrf 	y0,1
		bcf		STATUS,C	;y=y/8 ; 
		rrf		y1,1
		rrf 	y0,1
		call	add_xy		;(32bit)(32bit){y(32bit)	;x==y*(125+ 1/2+ 1/8)

		bcf		STATUS,C	;y=y/16 ; 						;25cycle
		rrf		y1,1
		rrf 	y0,1
		call	add_xy		;(32bit)(32bit){y(32bit)	;x==y*(125+ 1/2+ 1/8+ 1/16)

		bcf		STATUS,C	;X= x*(125+ 1/2+ 1/8+ 1/16) /16	;14cycle
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	;
		rrf		x1,1
		rrf		x0,1
		movf	x0,0
		movwf	v0		;(v0 =0 ` 108)

mv35	;35cycleFrom mv35- mv4
		btfsc	mode,0		;if SW-2 OFF, x=x ;-40`+20dBm
		goto	mv36
		movlw	D'44'
		goto	mv37

mv36	movlw	D'24'
		btfsc	mode,1		;if SW-2 OFF, x=x;-60`+00dBm
		goto	mv37
		movlw	D'4'						;-80`-20dBm
		goto	mv37

mv37	movwf	y0
		movf	y0,0
		subwf	v0,1	;v0=v0+ (256-y0)  (yo=48, 28, or 8)

		movlw	D'0'
		btfsc	STATUS,C	; if v0<0, then v0=0
		movf	v0,0
		movwf	v0

		movlw	D'63'
		subwf	v0,0	;W=v0 +(256-63)
		movlw	D'63'
		btfss	STATUS,C
		movf	v0,0
		movwf	v0		

mv4		movf	v0,0
		subwf	pV0,0		;W=pV0 + (256- v0)
		btfsc	STATUS,C	;if pV0 >=v0, then x1=pV0 & x0=v0
		goto	mv45	;pV0 >=v0
		goto	mv43	;pV0 < v0 

mv43	movf	pV0,0
		movwf	x1			;pV0 < v0
		movf	x1,0
		btfss	STATUS,Z	;if x1=0, then not decf
		decf	x1,1	;x0  > x1// Dot@1
	
		movf	v0,0		;x1 < x0
		movwf	x0
		goto	mv5

mv45	movf	v0,0		;pV0 >= v0	
		movwf	x1			;x0  > x1	
		movf	x1,0
		btfss	STATUS,Z	;if x1=0, then not decf
		decf	x1,1	;x0  > x1// Dot@1	
		
		movf	pV0,0
		movwf	x0	

mv5	; firm 	pD_n (consolidatea v0f[^ +@DotBar), x0  > x1
		;135cycle
		movf	v0,0
		movwf	pV0
				;;smaller of pV0/V0; @x1
				;;bigger of pV0/V0; @x0
		call	Dot_x0	;bigger@ x0	@Bar<G0-G7> // x0>x1 	;50cycle
		call	Dot_x1	;smaller x1	@Bar<sG0-sG7>				;50cycle
		call	nDot  ;smaller@; comf  Bar<sG0-sG7>			;10cycle

		movf	sG0,0	;smaller@				;24cycle
		andwf	G0,0	;bigger@
		iorwf	pD0,1	;	

		movf	sG1,0
		andwf	G1,0
		iorwf	pD1,1

		movf	sG2,0
		andwf	G2,0
		iorwf	pD2,1

		movf	sG3,0
		andwf	G3,0
		iorwf	pD3,1

		movf	sG4,0
		andwf	G4,0
		iorwf	pD4,1

		movf	sG5,0
		andwf	G5,0
		iorwf	pD5,1

		movf	sG6,0
		andwf	G6,0
		iorwf	pD6,1
	
		movf	sG7,0
		andwf	G7,0
		iorwf	pD7,1	

main6	call	L_dot	;N_cl, pD_n(;v0dް) čs	;;1610cycle@870cycle
		call	N12_inc	 ;incf	N_cl & N_12
		decfsz	cn_cl,1	;cn_cl=101@count down
		goto	main2

	;	movlw	D'112'	
	;	subwf	N_cl,0 	
	;	btfss	STATUS,Z	;if N_cl=0, then goto main
	;	goto	main2
	;	nop	;-----
		bcf		INTCON,GIE	;GIE=1 disable, 
		movlw	D'12'
		movwf	N_cl
		clrf	N_12
		clrf	N_12sub
		goto 	main
	;=================
	;----------------------
	;A/DϊJn@@AN0|[g@AiO	
adloop			;50cycle		;acquisition time wait 25usec	
		bsf  	STATUS,RP0	;oN1
		movlw	B'11000101'	;pinset(AN4=D,AN3=Ref+,AN2=D,AN1=Analog,AN0=Analog) resultE
		movwf	ADCON1
		bcf  	STATUS,RP0	;oN0

		movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol	nop  	;17cycle
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling; 2usec x12=24usec
		movf	ADRESH,0
		movwf	val1		;ADϊʂ@val1/ADHɎ荞݁@10bit=max1023
		bsf  	STATUS,RP0	;oN1
		movf	ADRESL,0
		bcf  	STATUS,RP0	;oN0
		movwf	val0

		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset

		movf	val1,0
		subwf	ADH,0		;W=ADH +(256-vall)
		btfss	STATUS,C	;if C=0, then goto ad_5
		goto	ad_5	;ADH/ADL replace

		btfss	STATUS,Z	;if Z=0, then goto ad_5		
		goto	ad_end		

		movf	val0,0
		subwf	ADL,0		;W=ADL +(256-val0)		
		btfss	STATUS,C	;if C=0, then goto ad_5				
		goto	ad_5
		goto	ad_end

ad_5	movf	val0,0	;ADH/ADL replace
		movwf	ADL
		movf	val1,0
		movwf	ADH
	;-----------------------
ad_end	return
	;==========================================
TMset	nop			;1sec=2,000,000Hz x(1/100)=20,000
				;1sec/ ;PSA;128x TMR156=19,968 //256-156=100
				;0.5sec/ ;PSA;128x TMR78=9,984 //256-78=178
				;0.1sec/ ;PSA;16x TMR125=2,000 //256-125=131

		movlw	B'00010110'	;;prescaler 1/128 set 	;1sec/
		btfss	mode,2								
		goto	TM17								

		movlw	B'00010110'	;;prescaler 1/128 set ;;0.5sec/
		btfss	mode,3								
		movlw	B'00010011'	;;prescaler 1/16 set ;;0.1sec

TM17	bsf  	STATUS,RP0	;oN1
		movwf	OPTION_REG	
		bcf		STATUS,RP0	;oN0

		movlw	D'100'	;	;1sec/
		btfss	mode,2	
		goto	TM19

TM18	movlw	D'178'	;;0.5sec/
		btfss	mode,3	
		movlw	D'131'	;;0.1sec

TM19	movwf	TMR0
		return
	;========================================================
			;***********10sline********
N12_inc	
		incf	N_cl,1
		;--
		incf	N_12,1		;*****************
		incf	N_12sub,1
		movlw	D'10'		;*****************
		subwf	N_12,0	;W=N_12 +(256-10)
		movlw	D'0'	
		btfss	STATUS,Z	;if N_12=10, then N_12=0
		movf	N_12,0
		movwf	N_12		;*****************
		return	;***********12sline********
	;========================================================
Dot_x0	;;	x0>x1		;
		clrf	G0	;56` max x0=63	
		clrf	G1	;48` max x0=55		
		clrf	G2	;40` max x0=47
		clrf	G3	;32` max x0=39
		clrf	G4	;24` max x0=31
		clrf	G5	;16` max x0=23
		clrf	G6	;8 ` max x0=15
		clrf	G7	;0 ` max x0=7

Dt0		movlw	D'8'	;0 ` max x0=7 
		subwf	x0,1	;x0=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt8
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G7	
		return

Dt8		comf	G7,1
		movlw	D'8'	;8 ` max x0=15
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt16
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G6
		return

Dt16	comf	G6,1
		movlw	D'8'	;16` max x0=23
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt24
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G5
		return

Dt24	comf	G5,1
		movlw	D'8'	;24` max x0=31
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt32
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G4
		return

Dt32	comf	G4,1
		movlw	D'8'	;32` max x0=39
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt40
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G3
		return

Dt40	comf	G3,1
		movlw	D'8'	;40` max x0=47
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt48
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G2
		return

Dt48	comf	G2,1
		movlw	D'8'	;48` max x0=55		
		subwf	x0,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	Dt56
		movf	x0,0
		addlw	D'8'
		call	R_DotBar
		movwf	G1
		return

Dt56	comf	G1,1	;56` max x0=63
		movf	x0,0
		call	R_DotBar
		movwf	G0
		return
	;-----------
Dot_x1	;;	x0>x1
		clrf	sG0	;56` max x0=63	
		clrf	sG1	;48` max x0=55		
		clrf	sG2	;40` max x0=47
		clrf	sG3	;32` max x0=39
		clrf	sG4	;24` max x0=31
		clrf	sG5	;16` max x0=23
		clrf	sG6	;8 ` max x0=15
		clrf	sG7	;0 ` max x0=7

nDt0	movlw	D'8'	;0 ` max x0=7 
		subwf	x1,1	;x0=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt8
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG7	
		return

nDt8	comf	sG7,1
		movlw	D'8'	;8 ` max x0=15
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt16
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG6
		return

nDt16	comf	sG6,1
		movlw	D'8'	;16` max x0=23
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt24
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG5
		return

nDt24	comf	sG5,1
		movlw	D'8'	;24` max x0=31
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt32
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG4
		return

nDt32	comf	sG4,1
		movlw	D'8'	;32` max x0=39
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt40
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG3
		return

nDt40	comf	sG3,1
		movlw	D'8'	;40` max x0=47
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt48
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG2
		return

nDt48	comf	sG2,1
		movlw	D'8'	;48` max x0=55		
		subwf	x1,1	;W=x0 +(256-8)
		btfsc	STATUS,C
		goto	nDt56
		movf	x1,0
		addlw	D'8'
		call	R_DotBar
		movwf	sG1
		return

nDt56	comf	sG1,1	;56` max x0=63
		movf	x1,0
		call	R_DotBar
		movwf	sG0
		return
	;-----------
nDot	nop	;white dot Black dot
		comf	sG0,1
		comf	sG1,1
		comf	sG2,1
		comf	sG3,1
		comf	sG4,1
		comf	sG5,1
		comf	sG6,1
		comf	sG7,1

		movf	v0,1		;if v0=0 & pV0=0, then sG0.0=1
		btfss	STATUS,Z	;
		return
		movf	pV0,1
		btfsc	STATUS,Z	;
		bsf		sG7,0		
		return		
;----------------------------------
initLCD	nop		;;	;;===CS1
		bcf		CS	;CS1
		bcf		DI		;Display ON/OFF
		bcf		E
		movlw	B'00111110'	;Display /OFF
		movwf	p_d8
		call	lcd

		movlw	B'11000000'	;Display start line register 0-line
		movwf	p_d8
		call	lcd

		movlw	B'01000000'	;Column addess set 0-line
		movwf	p_d8
		call	lcd		

		movlw	B'10111000'	;page addess set 0-page
		movwf	p_d8
		call	lcd		

		movlw	B'00111111'	;Display /ON
		movwf	p_d8
		call	lcd
			;;===CS2
		bsf		CS	;CS2
		bcf		DI		;Display ON/OFF
		bcf		E
		movlw	B'00111110'	;Display /OFF
		movwf	p_d8
		call	lcd

		movlw	B'11000000'	;Display start line register 0-line
		movwf	p_d8
		call	lcd

		movlw	B'01000000'	;Column addess set 0-line
		movwf	p_d8
		call	lcd		

		movlw	B'10111000'	;page addess set 0-page
		movwf	p_d8
		call	lcd		

		movlw	B'00111111'	;Display /ON
		movwf	p_d8
		call	lcd
		return
	;===================
pD_set	;N_12(;Line=10s),Ă邱	;100cycle
		;================================
		movlw	D'8'	;==setting pD0-pD7
		movwf	cn
		movlw	pD0	;address of pB0dot
		movwf	FSR
		clrf	N_Pg
pDs10	call	R_Gridpage		;N_pg, N_12čs
		movwf	INDF
		incf	FSR,1
		incf	N_Pg,1
		decfsz	cn,1
		goto	pDs10	
		return			;==END of setting pD0-pD7
		;================================
	;==================
L_dot	;N_cl, pD_n(;v0dް) Ă邱	;1610cycle@870cycle
		bsf  	STATUS,RP0	;oN1
		movlw	B'00000000'	;rb.0-rb.7sout  
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0

		movlw	D'8'
		movwf	cn
		movlw	pD0	;; 0page B8
		movwf	FSR	;set address of pD0	
		clrf	N_Pg	;;dotłĂ@active  Page Pg_act=0 `7

Ld1		call	lcd_clm		;Column set /		;70cycle
		call	lcdpg		;N_Pg;Page set		;15cycle

		movf	INDF,0		;Data of pD0-pD7
		movwf	d8	

Ld2		call	R_lcdat		;;Data set		;15cycle	
		incf	FSR,1
		incf	N_Pg,1
		decfsz	cn,1
		goto	Ld1
		return
	;==============
dspdBm	;;Displaying ;20dBm, 00dBm, or -20dBm
	
		clrf	N_Pg
		call	CharadB		;Page0

		incf	N_Pg,1		;Page1	
		call	CharadB	
		incf	N_Pg,1		;Page2	
		call	CharadB	
		incf	N_Pg,1		;Page3	
		call	CharadB	
		incf	N_Pg,1		;Page4	
		call	CharadB	
		incf	N_Pg,1		;Page5	
		call	CharadB	
		incf	N_Pg,1		;Page6	
		call	CharadB	
		incf	N_Pg,1		;Page7	
		call	CharadB
		return
	;=============
CharadB	movlw	D'0'
		movwf	N_cl	;0񂩂11;increment
		btfss	mode,0	;Displaying ;20dBm, 00dBm, or -20dBm
		goto	dB20

		btfss	mode,1	
		goto	dB80
		goto	dB00

dB20	movf	N_Pg,0
		call	dBplus20
		movwf	val0		;Figure 荞	H'20'@H'00'
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig	;;݁@1ځ`4	

		movf	N_Pg,0
		addlw	H'8'
		call	dBplus20
		movwf	val0		;Figure 荞	H'20'@H'00'
		call	dBF1	;;݁@5ځ`12	
		return

dB00	movf	N_Pg,0
		call	dBplus00
		movwf	val0		;Figure 荞	H'20'@H'00'
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig		;;݁@1ځ`4	

		movf	N_Pg,0
		addlw	H'8'
		call	dBplus00
		movwf	val0		;Figure 荞	H'20'@H'00'
		call	dBF1	;;݁@5ځ`12
		return

dB80	movf	N_Pg,0
		call	dBminus20
		movwf	val0		;Figure 荞	H'20'@H'00'
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig		;;݁@1ځ`4	

		movf	N_Pg,0
		addlw	H'8'
		call	dBminus20
		movwf	val0		;Figure 荞	H'20'@H'00'
		call	dBF1	;;݁@5ځ`12
		return
		;----
		;----------------------------------
dBFig	movlw	B'00001111'	;N_clė	
		andwf	val0,0
		movwf	poi
	
		movlw	H'10'
		btfss	Font,6	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara
		movlw	H'0'
		addwf	poi,1
		movf	poi,0
		call	Font1st
		movwf	char0	;;@1	

		movf	poi,0
		call	Font2nd
		movwf	char1	;;@2	

		movf	poi,0
		call	Font3rd
		movwf	char2	;;@3	

		clrf	char3	;;@4
		return

dBF1	movlw	B'11110000'	;N_clė
		andwf	val0,0
		movwf	poi
		swapf	poi,0
		movwf	poi

		movlw	H'10'
		btfss	Font,5	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara
		movlw	H'0'
		addwf	poi,1
		movf	poi,0
		call	Font1st
		movwf	char4	;;@5	

		movf	poi,0
		call	Font2nd
		movwf	char5	;;@6	

		movf	poi,0
		call	Font3rd
		movwf	char6	;;@7	

		clrf	char7	;;@8

		movlw	B'00001111'
		andwf	val0,0
		movwf	poi

		movlw	H'10'
		btfss	Font,4	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara
		movlw	H'0'
		addwf	poi,1
		movf	poi,0
		call	Font1st
		movwf	char8	;;@9	

		movf	poi,0
		call	Font2nd
		movwf	char9	;;@10	

		movf	poi,0
		call	Font3rd
		movwf	char10	;;@11

		clrf	char11	;;@12	

		;-------
		;-------
		bsf  	STATUS,RP0	;oN1
		movlw	B'00000000'	;rb.0-rb.7sout  
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0

		call	lcd_clm		;Column set /
		call	lcdpg		;;Page set	

		movf	char0,0	;;@1	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char1,0	;;@2	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char2,0	;;@3	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char3,0	;;@4	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char4,0	;;@5	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char5,0	;;@6	
		movwf	p_d8 
		call	lcdat		;p_d8 Write display data

		movf	char6,0	;;@7	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char7,0	;;@8	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char8,0	;;@9	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char9,0	;;@10	
		movwf	p_d8 
		call	lcdat		;p_d8 Write display data

		movf	char10,0	;;@11	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data

		movf	char11,0	;;@12	
		movwf	p_d8 
		call	lcdat			;p_d8 Write display data
		return
	;==============
SECDSP	;;Displaying ;1.0SEC ,0.5SEC, 0.1SEC
	
		clrf	N_Pg
		call	CharSEC		;Page0

		incf	N_Pg,1		;Page1	
		call	CharSEC	
		incf	N_Pg,1		;Page2	
		call	CharSEC	
		incf	N_Pg,1		;Page3	
		call	CharSEC	
		incf	N_Pg,1		;Page4	
		call	CharSEC	
		incf	N_Pg,1		;Page5	
		call	CharSEC	
		incf	N_Pg,1		;Page6	
		call	CharSEC	
		incf	N_Pg,1		;Page7	
		call	CharSEC
		return
	;=============
CharSEC	movlw	D'114'
		movwf	N_cl	;114񂩂12;increment
		btfss	mode,2	;Displaying ;;1.0SEC ,0.5SEC, 0.1SEC
		goto	SE10

		btfss	mode,3	
		goto	SE01
		goto	SE05

SE10	movf	N_Pg,0
		call	sec10
		movwf	val0		;Figure 荞	
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig

		movf	N_Pg,0
		addlw	H'8'
		call	sec10
		movwf	val0		;Figure 荞	
		call	dBF1
		return

SE05	movf	N_Pg,0
		call	sec05
		movwf	val0		;Figure 荞	
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig

		movf	N_Pg,0
		addlw	H'8'
		call	sec05
		movwf	val0		;Figure 荞	
		call	dBF1
		return

SE01	movf	N_Pg,0
		call	sec01
		movwf	val0		;Figure 荞	
		movf	val0,0
		andlw	B'11110000'	
		movwf	Font	;From left No/+16 for 1st Chara/ 2nd Chara/ 3rd Chara

		call	dBFig

		movf	N_Pg,0
		addlw	H'8'
		call	sec01
		movwf	val0		;Figure 荞	
		call	dBF1
		return
		;=================
Spa_ce	movlw	D'8'	;N_clĂ
		movwf	cn
		clrf	N_Pg
Sp1		call	lcd_clm
		call	lcdpg
		clrf	d8
		call	R_lcdat
		incf	N_Pg,1
		decfsz	cn,1
		goto	Sp1
		return

		;==============-
lcd_clm	movlw	D'64'	;;Clomn ʂAN_cl=O`PQV	;70cycle
		subwf	N_cl,0	; W=N_cl +(256-64)  
		btfss	STATUS,C	;if c=1(64 >N_cl), then N_cl=N_cl -64
		goto	LC_CS1	
		goto 	LC_CS2

LC_CS2	movlw	D'64'	;;Clomn ʂAO`PQV
		subwf	N_cl,0	; W=N_cl +(256-64)  
		movwf	clmn
		bsf		CS		;CS2	;if c=1(64 < N_cl <127), CS2	
		goto	lcd_c2
		
LC_CS1	movf	N_cl,0
		movwf	clmn
		bcf		CS		;CS1	;if c=1(64 >N_cl), CS1		

lcd_c2	bcf		DI		;Display instruction	:;55cycle
		movf	clmn,0		;Column set
		xorlw	B'01000000'	;LCD Command
		movwf	p_d8
		call	lcd		;Colmn set
		return
	;---------------------
lcdpg	movf	N_Pg,0		;Page set	;55cycle@15cycle
		call	R_NPg
		movwf	d8
		call	lcd4
		;;	xorlw	B'10111000'	;LCD Command
			;;movwf	p_d8
		;	;bcf		DI		;Display instruction
		;	;call	lcd		;Page set
		return	
	;---------------------
lcdat	bsf		DI		;Display data	;45cycle
		call	lcd		;Data set
		return	

R_lcdat	bsf		DI		;Display data	;45cycle 15cycle 
		call	lcd4		;Data set
		return		
	;-------------
lcd		nop		;Write display data	;40cycle (20cycle+10usec)
		rrf		p_d8,1		;1	;p_d8 Reverse@d8
		rlf		d8,1		;
		rrf		p_d8,1		;2
		rlf		d8,1		;
		rrf		p_d8,1		;3
		rlf		d8,1	
		rrf		p_d8,1		;4
		rlf		d8,1		;
		rrf		p_d8,1		;5
		rlf		d8,1
		rrf		p_d8,1		;6
		rlf		d8,1		;
		rrf		p_d8,1		;7
		rlf		d8,1
		rrf		p_d8,1		;8
		rlf		d8,1
lcd4	bcf		E		;9cycle
		movf	d8,0
		movwf	PORTB
		bsf		E
		bcf		E
		call	wt10us
		return
;----------------------------------
wt10us  return	;temp
		movlw	D'5'
		movwf	wait_cn
		goto	wait_us

wt1ms   movlw	D'1'
		movwf	wait_cn
		goto	wait_ms
; -------------------------------------------------------------------
wait_us				;3 steps=1.2ʂ̃JEg
wait_us0	decfsz	wait_cn,1
		goto	wait_us0
		return

;
;		I[_[̃EFCg
;
wait_ms
wait_ms0
		movlw	D'0'	
		movwf	wait_cn2
wait_ms1
		nop  	
		nop  
		nop  
		nop  
		nop	
		nop
		nop
		
		decfsz	wait_cn2,1
		goto	wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0
		return

;---------------------------------------------------------	
;	Z		(32bit)(32bit)|y(32bit)@
;
sub_xy
		movf	y0,0		;sub	x[0],y[0]
		subwf	x0,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y1,0		;sub	x[1],y[1]
		subwf	x1,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y2,0		;sub	x[2],y[2]
		subwf	x2,1
		movlw	D'1'
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y3,0		;sub	x[3],y[3]
		subwf	x3,1
		return
;--------------------------------------------------------------------
; 	Z	(32bit)(32bit){y(32bit)@
;
add_xy				
		movf	y0,0		;add	x[0],y[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y1,0		;add	x[1],y[1]
		addwf	x1,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0		;add	x[2],y[2]
		addwf	x2,1	
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y3,0		;add	x[3],y[3]
		addwf	x3,1	
		return
;---------------------------------------------------------------------
;	RQrbgoCiPOiϊ
;
;	valɂRQrbgf[^uBival[3]:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[0]:dec[1]:...:dec[8]:dec[9])
;		dec[0]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
	

dcmain
		movlw	H'4D'		;mov	fsr,#dec_top		; i[ꏊl
		movwf	FSR		
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
		call	devide
		call	devide
		call	devide

		call	devide
		call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
	;	return
		goto	zblank
;
;		POTu[`
;		POŏZ܂
;
devide		movlw	D'32'
		movwf	cn			; RQrbgԂ
		
		clrf	val_m
devide0		
		bcf  	STATUS,C
		rlf  	val0,1
		rlf  	val1,1
		rlf  	val2,1
		rlf  	val3,1
		rlf  	val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m
		btfsc	STATUS,C
		incf	val0,1

		decfsz	cn,1
		goto	devide0
		
		decf	FSR,1
		movf	val_m,0
		movwf	INDF		; ]
		return
zblank
		movlw	H'43'		;addres of dec[0]		; i[ꏊl
		movwf	FSR			
		movlw	D'9'
		movwf	cn			; 9񂭂Ԃ
zb1  	
		movf	INDF,1
		btfsc	STATUS,Z	;if INDF=not 0, then return
		goto	zb2
		return

zb2		movlw	H'E'		;DSP Blank 
		movwf	INDF
		incf	FSR,1
		decfsz	cn,1
		goto	zb1
		return
		

;----------------------------------------end of 10iϊ
;-----------------------------------------------------------------------
;	|Z		x[32bit]=y[24bit] * N[8bit]
;
;	y24rbgf[^uB
;		iy[3]:y[2]:y[1]:y[0]) 
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN		clrf	x3
		clrf	x2
		clrf	x1
		clrf	x0
			
		movlw	D'8' 	
		movwf	cn
mult0		
		btfss	N,0
		goto	mutpas
		
		movf	y0,0		;add	x[0],y[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C	
		addwf	x3,1
		
		movf	y1,0		;add	x[1],y[1]
		addwf	x1,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0		;add	x[2],y[2]
		addwf	x2,1	
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y3,0		;add	x[3],y[3]
		addwf	x3,1	
		
mutpas		bcf  	STATUS,C
		rlf  	y0,1
		rlf  	y1,1
		rlf 	y2,1
		rlf  	y3,1
		btfsc	STATUS,C	
		bsf  	y0,0

		bcf  	STATUS,C
		rrf  	N,1
		btfsc	STATUS,C
		bsf  	N,7

		decfsz	cn,1		;djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot		bcf 	STATUS,C
		rrf  	y3,1
		rrf  	y2,1
		rrf  	y1,1
		rrf  	y0,1
		btfsc	STATUS,C
		bsf  	y3,7

		decfsz	cn,1		
		goto	multrot
		return
;---------------------------end of |Z
		END

	
